# University of Notre Dame
# Course CSE 40537 / 60537 - Biometrics - Spring 2022
# Instructor: Daniel Moreira (dhenriq1@nd.edu)
# Fingerprint Recognition
# 01. Acquisition-module stub.
# Language: Python 3
# Needed libraries: OpenCV (https://opencv.org/)
# Quick install (with PyPI - https://pypi.org/):
# execute "pip3 install opencv-contrib-python" on command shell.

import cv2


# Stub function to acquire a fingerprint sample from a file, given its path.
# Parameters:
# <file_path> - The path to the image file containing one fingerprint sample.
# <view> - True if loaded fingerprint must be shown in a proper window, False otherwise.
# Returns the obtained fingerprint as a numpy 2D uint8 array.
def acquire_from_file(file_path, view=False):
    # reads the fingerprint image from the given file path
    # and returns it
    fingerprint = cv2.imread(file_path)

    # show the read fingerprint, if it is the case
    if view:
        cv2.imshow('press any key', fingerprint)
        cv2.waitKey(0)

    print('[INFO] Acquired fingerprint from file.')
    return fingerprint

# TODO
# New functions may be added here, targeting either:
# 1. Solution test execution (loading of various genuine and impostor fingerprint pairs); or
# 2. Enrollment scenario (loading of fingerprint + ID to enroll in a system); or
# 3. Verification scenario (loading of fingerprint + ID, to verify claimed identity); or
# 4. Recognition scenario (loading of fingerprint, to find identity).
